var antlr4 = require('antlr4/index');
var QueryExpressionLexer = require('generated-parser/QueryExpressionLexer');
var QueryExpressionParser = require('generated-parser/QueryExpressionParser');

function cloneTokens(input) {

  var chars = new antlr4.InputStream(input.toString());
  var lexer = new QueryExpressionLexer.QueryExpressionLexer(chars);
  var tokens  = new antlr4.CommonTokenStream(lexer);
  var parser = new QueryExpressionParser.QueryExpressionParser(tokens);
  parser.buildParseTrees = true;
  var tree = parser.parse();
  console.log("Parsed: "+ tree);
  updateTree(tree, parser.ruleNames);
  
  var cache = [];
  var clone = JSON.parse(
    JSON.stringify(tokens, function(key, value) {
      if (typeof value === 'object' && value !== null) {
        if (cache.indexOf(value) !== -1) {
          // Duplicate reference found
          try {
            // If this value does not reference a parent it can be deduped
            return JSON.parse(JSON.stringify(value));
          } catch (error) {
            // discard key if value cannot be deduped
            return;
          }
        }
        // Store value in our collection
        cache.push(value);
      }
      return value;
    }));
  return clone;
}
